package com.yun.task.service.impl;


import com.alibaba.fastjson.JSONObject;
import com.bwie.common.domain.*;
import com.bwie.common.result.Result;
import com.yun.common.core.domain.R;
import com.yun.task.mapper.TaskMapper;
import com.yun.task.service.TaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import javax.xml.soap.Node;
import java.lang.reflect.Field;
import java.sql.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author Dunzhida
 * data 2023/7/27 16:15
 * fileName TaskServiceImpl
 */
@Service
public class TaskServiceImpl implements TaskService {


    @Autowired
    private TaskMapper taskMapper;

//    jdbcTemplate是Spring框架中的一个核心类，用于简化在Java应用程序中执行SQL操作的过程。
//    提供了一种方便、灵活和安全的方式来访问数据库，并处理与数据库交互相关的细节
    @Autowired
    private JdbcTemplate jdbcTemplate;


/*
*
*
* daedadawpdjawiofhnoaffdmafmgmpmg凡是美国福克斯没干过可能凡是美国模式每个网格法兰克福哪里呢
*
*
* */
    /*
    * 查询所有数据库
    * */
    @Override
    public List<String> findBydatabase() {
        String sql = "SELECT schema_name FROM information_schema.schemata";
        return jdbcTemplate.queryForList(sql,String.class);
    }



    /*
    * 根据数据库查询数据库里面的所有表
    * */
    @Override
    public List<String> findByTable(String database) {
        String sql = "show tables from `"+database+"`";
        return jdbcTemplate.queryForList(sql, String.class);
    }


    /*
    * 根据数据库和数据表查询表中的所有字段
    * */

    @Override
    public List<Mysql> findByField(String datatable, String database) {
//        选择要查询的列，包括列名、数据类型、是否可为空和列注释。
        String sql = "SELECT COLUMN_NAME, DATA_TYPE, IS_NULLABLE, COLUMN_COMMENT "+
//        所有列的相关信息
                "FROM INFORMATION_SCHEMA.COLUMNS "+
//        通过指定的表模式和表名来筛选出特定的表。
                "WHERE TABLE_SCHEMA = ? AND TABLE_NAME = ?";


 //          来执行SQL查询并返回结果  执行的SQL语句 数据库名 表名
        List<Map<String, Object>> rows = jdbcTemplate.queryForList(sql, database, datatable);

        List<Mysql> resultList = new ArrayList<>();

        //  以循环的方式将查出来的字段属性存入对象中
        // 列名 字段类型 是否为null 字段描述
        for (Map<String, Object> row : rows) {
            Mysql mysql = new Mysql();
            mysql.setCOLUMNNAME((String) row.get("COLUMN_NAME"));
            mysql.setDATATYPE((String) row.get("DATA_TYPE"));
            mysql.setISNULLABLE((String) row.get("IS_NULLABLE"));
            mysql.setCOLUMN_COMMENT((String) row.get("COLUMN_COMMENT"));
            resultList.add(mysql);
        }

        return resultList;
    }





    /*
    * 进行添加输入主表节点
    * */
    @Override
    public void addImport(NodeOne nodeOne) {
        //获取输入的多个字段进行join切割 成string类型
        String firstFieldsString = String.join(",", nodeOne.getNodeOneFields());
        nodeOne.setNodeOneField(firstFieldsString);

        taskMapper.addImport(nodeOne);

        taskMapper.updateMiddle(nodeOne.getImport1Id());
    }



    /*
    * 输入关联表节点
    * */
    @Override
    public void addImport2(NodeTwo nodeTwo) {
        //获取输入的多个字段进行join切割 成string类型
        String firstFieldsString = String.join(",", nodeTwo.getNodeTwoFields());
        nodeTwo.setNodeTwoField(firstFieldsString);

        taskMapper.addImport2(nodeTwo);

        taskMapper.updateMiddle2(nodeTwo.getImport2Id());
    }

    /*
    * 将节点任务id 添加到配置表中
    * */
    @Override
    public void createMiddle(Config config) {
        taskMapper.createMiddle(config);
    }

    @Override
    public void addImport3(NodeThree nodeThree) {
//        String join = String.join(",", nodeThree.getNodeFieldArr());
//        nodeThree.setNodeFields(join);
        taskMapper.addImport3(nodeThree);
    }

    @Override
    public List<NodeThree> taskList() {
      List<NodeThree> threes = taskMapper.taskList();
      return threes;
    }

    @Override
    public List<NodeThree> JoinList(String nodeOneDatatable, String nodeTwoDatatable, String nodeOneField, String nodeTwoField,String nodeThreeWay) {
        String substring = nodeThreeWay.substring(0 , 4);
        String substring1 = nodeThreeWay.substring(4, 8);
        String sql =" select * FROM "+nodeOneDatatable +" "+ substring +" "+substring1 +" "+ nodeTwoDatatable+" ON "+nodeOneDatatable+"."+nodeOneField+" = "+nodeTwoDatatable+"."+nodeTwoField;
        List<NodeThree> nodeThrees = jdbcTemplate.queryForList(sql, NodeThree.class);
        return nodeThrees;
    }

    @Override
    public NodeThree FileList(Integer nodeThreeId) {
//        通过Id查询对象
        NodeThree nodeThree = taskMapper.FileList(nodeThreeId);

//        获取对象内容  在进行查询返回集合
        return nodeThree;

    }

//         String substring = nodeThreeWay.substring(0 , 4);
//        String substring1 = nodeThreeWay.substring(5, 9);
//        String sql =" select * FROM "+nodeOneDatatable +" "+ substring +" "+substring1 +" "+ nodeTwoDatatable+" ON "+nodeOneDatatable+"."+nodeOneField+" = "+nodeTwoDatatable+"."+nodeTwoField;
////       String sql=" SELECT  TABLE_NAME, COLUMN_NAME, DATA_TYPE, IS_NULLABLE, COLUMN_COMMENT  FROM  information_schema.COLUMNS WHERE (TABLE_NAME = '"+nodeOneDatatable+"' OR TABLE_NAME = '"+nodeTwoDatatable+"') ORDER BY TABLE_NAME, ORDINAL_POSITION;";
//        List<Map> maps = jdbcTemplate.queryForList(sql, Map.class);
//
//
////       List<Mysql> resultList = new ArrayList<>();
////        for (Map<String, Object> row : rows) {
////            Mysql mysql = new Mysql();
////            mysql.setCOLUMNNAME((String) row.get("COLUMN_NAME"));
////            mysql.setDATATYPE((String) row.get("DATA_TYPE"));
////            mysql.setISNULLABLE((String) row.get("IS_NULLABLE"));
////            mysql.setCOLUMN_COMMENT((String) row.get("COLUMN_COMMENT"));
////            resultList.add(mysql);
////        }
//        return maps;
//
    @Override
    public Result FileLists(String nodeOneDatatable, String nodeTwoDatatable, String nodeOneField, String nodeTwoField, String nodeThreeWay,String nodeFields) {




            String substring =null;
            String substring1=null;
//            判断联查方式
            if (nodeThreeWay.equals("left join")){

                substring = nodeThreeWay.substring(0 , 4);
                substring1 = nodeThreeWay.substring(5, 9);

            }else if (nodeThreeWay.equals("right join")){

                substring = nodeThreeWay.substring(0,5);
                substring1 = nodeThreeWay.substring(6,10);
            }


//            进行对源数据查询
//            String sql1 =" select * FROM "+nodeOneDatatable +" "+ substring +" "+substring1 +" "+ nodeTwoDatatable+" ON "+nodeOneDatatable+"."+nodeOneField+" = "+nodeTwoDatatable+"."+nodeTwoField;
//            List<Map<String, Object>> maps = jdbcTemplate.queryForList(sql1);
//
//            List<Map> maps1 = taskMapper.FileLists(nodeOneDatatable,  nodeTwoDatatable,  nodeOneField,  nodeTwoField,  nodeThreeWay, nodeFields);
//
//            StringBuilder sql = new StringBuilder("insert into t_info(");
//                StringBuilder resultSql = null;
//                for (String s : nodeFields.split(",")) {
//                    sql.append(s).append(",");
//                    if (sql.toString().endsWith(",")){
//                        StringBuilder stringBuilder = new StringBuilder(sql.substring(0, sql.length() - 1));
//                        resultSql=stringBuilder.append(")");
//                    }
//                }
//                System.out.println("result:"+resultSql);
//                System.out.println("---------------------------------------------------------------");
//
//                String[] split = nodeFields.split(",");
//                String value = "values(";
//                for (int j = 0; j < split.length; j++) {
//                    value+=",#{}";
//                }
//                String sqlsql=resultSql+value+")";
//                System.out.println(sqlsql);


                Connection connection=null;
                ResultSet resultSet=null;
                try {
        //            连接源数据
                    connection = DriverManager.getConnection("jdbc:mysql://124.221.14.100:3306/six", "root", "dzd123");
        //            进行对源数据查询
                    String sql1 =" select * FROM "+nodeOneDatatable +" "+ substring +" "+substring1 +" "+ nodeTwoDatatable+" ON "+nodeOneDatatable+"."+nodeOneField+" = "+nodeTwoDatatable+"."+nodeTwoField;
                    PreparedStatement preparedStatement = connection.prepareStatement(sql1);
                    resultSet = preparedStatement.executeQuery();
        //            选取需要得字段

                    while (resultSet.next()){
                        String name = resultSet.getString("name");
                        int age = resultSet.getInt("age");
                        String phone = resultSet.getString("phone");
                        String password = resultSet.getString("password");
                        String email = resultSet.getString("email");

                        //                连接目标系统
                        Connection connection1 = DriverManager.getConnection("jdbc:mysql://124.221.14.100:3306/six", "root", "dzd123");
        //                数据加载到目标系统中
                        PreparedStatement preparedStatement1 = connection1.prepareStatement("insert into t_info (name,age,phone,password,email) values (?,?,?,?,?)");
                        preparedStatement1.setString(1,name);
                        preparedStatement1.setInt(2,age);
                        preparedStatement1.setString(3,phone);
                        preparedStatement1.setString(4,password);
                        preparedStatement1.setString(5,email);

                        preparedStatement1.executeUpdate();
                        preparedStatement1.close();
                        connection1.close();
                    }
                    preparedStatement.close();

                } catch (SQLException throwables) {
                    throwables.printStackTrace();
                }finally {

                    try {
                        if (resultSet!=null){
                            resultSet.close();
                        }
                        if (connection!=null){
                            connection.close();
                        }

                    } catch (Exception exception) {
                        exception.printStackTrace();
                    }
                }


        return Result.success("完成");

    }

    @Override
    public Result loading(Integer nodeThreeId) {
//        String sql="insert into "+nodeThree.getNodeOneDatatable() +" VALUES ( "+nodeThree.getNodeOneField()+" )";

//        String nodeFields = String.join(",", nodeThree.getNodeFieldArr());
        NodeThree nodeThree = taskMapper.FileList(nodeThreeId);

        Integer  integer= taskMapper.loading(nodeThree.getNodeFields());

       return Result.success(integer);

    }


}
